"""
2F{XgnEWOf[^
̗vZ̉i\
@author: t.imai
"""
%matplotlib inline

import matplotlib.pyplot as plt
import numpy as np 
import pandas as pd
import tensorflow as tf

from tensorflow import keras
from tensorflow.keras import layers

# ͂镔
max_epochs = 1000                      # P̃Xebv̐
filename_train = f'{mount_dir}/MyDrive/Colab Notebooks/ex2_boston_traindata.csv'    # Ppf[^̃t@C
filename_test =  f'{mount_dir}/MyDrive/Colab Notebooks/ex2_boston_testdata.csv'      # mFpf[^̃t@C
explanatory_start_column = 2     # ϐ̍ŏ̗̗ԍ 2ڂł2
explanatory_end_column =12      # ϐ̍Ō̗̗ԍ 14ڂł14
outcome_column = 13          # ړIϐitf[^j̗ԍ 15ڂł15
# ͂͂܂

explanatory_variables = np.arange(explanatory_start_column-1, explanatory_end_column)    
outcome_variables = [outcome_column-1]               

'''
f[^̐
'''
df_train = pd.read_csv(filename_train, skiprows=[0], header=None)
temp_np_train = np.array(df_train.values.tolist())
x_train = temp_np_train[:, explanatory_variables]
y_train = temp_np_train[:, outcome_variables]    

df_test = pd.read_csv(filename_test, skiprows=[0], header=None)
temp_np_test = np.array(df_test.values.tolist())
x_test = temp_np_test[:, explanatory_variables]
y_test = temp_np_test[:, outcome_variables] 

# ̓f[^𐳋K
x_min = x_train.min(axis=0)
x_max = x_train.max(axis=0)
x_train = (x_train - x_min)/(x_max - x_min)
x_test = (x_test - x_min)/(x_max - x_min)

# f̍\z
model = tf.keras.models.Sequential([
  keras.layers.Dense(64, activation='relu'),
  keras.layers.Dense(64, activation='relu'), 
  keras.layers.Dense(64, activation='relu'),     
  keras.layers.Dense(1)
])

model.compile(optimizer='adam', loss='mse', metrics=['mae', 'mse'])

history = model.fit(x_train, y_train, epochs=max_epochs, verbose=0)

hist = pd.DataFrame(history.history)
hist['epoch'] = history.epoch
#pd.set_option('display.max_rows', 500)
print(hist)
#hist.tail()

test_scores = model.evaluate(x_test, y_test, verbose=2)
print('Test loss:', test_scores[0])
print('Test mae:', test_scores[1])


def plot_history(history):
  hist = pd.DataFrame(history.history)
  hist['epoch'] = history.epoch
 
  plt.figure()
  plt.xlabel('Epoch')
  plt.ylabel('Mean Abs Error')
  plt.plot(hist['epoch'], hist['mae'],
           label='Train Error')
  plt.legend()
 
  plt.figure()
  plt.xlabel('Epoch')
  plt.ylabel('Loss')
  plt.plot(hist['epoch'], hist['loss'],
           label='Train loss')
  plt.legend()
  plt.show()

plot_history(history)

# \lcsvt@Cɏo
val_y = model.predict(x_test)    
np.savetxt('prediction_boston.csv', val_y, delimiter=',')
print (val_y)    